package videowrapper;

import com.exercise.AndroidVideoCapture.MyCameraSurfaceView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;


import android.view.View;
import android.view.Gravity; 


import java.io.IOException;

import android.app.Activity;
import android.content.Context;
import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.hardware.Camera.CameraInfo;
import android.media.CamcorderProfile;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.Toast;

import android.content.Intent;
import android.content.IntentFilter;
import android.net.Uri;
import android.os.Environment;
import java.lang.Thread;
import android.os.Handler;

import java.text.SimpleDateFormat;
import java.util.Locale;

import java.util.List; 
import java.util.ArrayList; 
import java.io.File;
import java.io.FileOutputStream;

import android.os.CountDownTimer;
import java.util.concurrent.TimeUnit;

import android.content.pm.PackageManager;


@Events(values={"flash_toggled(flashOnOrOff As Boolean)", "max_duration_reached(maxdurationreached As Boolean)", "max_file_size_reached(maxsizereached As Boolean)", "recording_time_remaining(remainingtime As String)"})
@Author("Original project by: Andr.oid Eric, Adapted, modified, and wrapped by: Johan Schoeman")
@Version(1.01f)
@ShortName("AndroidVideoCapture")
//@DependsOn(values={"android-support-annotations"})
public class videoWrapper extends ViewWrapper<MyCameraSurfaceView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private MyCameraSurfaceView cv;
	private Camera myCamera;
        private MediaRecorder mediaRecorder;
	private SurfaceHolder surfaceHolder;
	private boolean recording = false;
        private boolean isFlashOn = false;
        private int currentZoomLevel = 0, maxZoomLevel = 0;
        private Handler mHandler = new Handler();


        public int QUALITY_1080P = 6;                                  //1920 x 1080
        public int QUALITY_2160P = 8;                                  //3840 x 2160
        public int QUALITY_480P = 4;                                   //720 x 480
        public int QUALITY_720P = 5;                                   //1280 x 720
        public int QUALITY_CIF = 3;                                    //352 x 288
        public int QUALITY_HIGH = 1;                                   //highest available resolution
//      public int QUALITY_HIGH_SPEED_1080P = 2004;
//      public int QUALITY_HIGH_SPEED_2160P = 2005; 
//      public int QUALITY_HIGH_SPEED_480P = 2002; 
//      public int QUALITY_HIGH_SPEED_720P = 2003;      
//      public int QUALITY_HIGH_SPEED_HIGH = 2001;     
//      public int QUALITY_HIGH_SPEED_LOW = 2000;    
        public int QUALITY_LOW = 0;                                    //lowest available resolution
        public int QUALITY_QCIF = 2;                                   //176 x 144
        public int QUALITY_QVGA = 7;                                   //320x240

        private int qualityvalue = 0;  
       /**
        * The ID of the front facing camera
        * If the ID is -1 after initialization then the device does not support a front facing camera
        * If the device has front and back cameras then the ID's will be BACK = 0 and FRONT = 1 after initialization
        * If the device has a back camera only then the ID's will be BACK = 0 and FRONT = -1 after initialization
        * If the device has a front camera only then the ID's will be BACK = -1 and FRONT = 0 after initialization
        */

        public int CAMERA_FRONT = -1;
       /**
        * The ID of the back facing camera
        * If the ID is -1 after initialization then the device does not support a back facing camera
        * If the device has front and back cameras then the ID's will be BACK = 0 and FRONT = 1 after initialization
        * If the device has a back camera only then the ID's will be BACK = 0 and FRONT = -1 after initialization
        * If the device has a front camera only then the ID's will be BACK = -1 and FRONT = 0 after initialization
        */
        public int CAMERA_BACK = -1;


        private int cntr = 0;
        private CountDownTimer counter;
        private String oldtimestring = "";
	private boolean cameraFront = false;
        private boolean debugMessages = false;

 
       /**
        * Initialize the videoWrapper class
        * Eventname = name of events that this class will raise in B4A
        * debugMessages = print debug messages to the log
        */
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
                if (hasCamera()) {
                    myCamera = getCameraInstance();
                    if(myCamera == null){
        	       Toast.makeText(ba.applicationContext, 
        			"Fail to get Camera", 
        			Toast.LENGTH_LONG).show();
                    } else {            
		        cv = new MyCameraSurfaceView(ba.context, myCamera);
                        this.setObject(cv);
                        recording = false;
                        addListener2();
                    }
                 } else {
        	       Toast.makeText(ba.applicationContext, 
        			"Device has no Camera", 
        			Toast.LENGTH_LONG).show();
                 }
 	}




      @Hide
      public void addListener2(){
        if(hasFlash()) {
//          BA.Log("Device has a flash");
          cv.setOnClickListener(new View.OnClickListener() {
              @Override
              public void onClick(View v) {
                if ((recording == true) && (isFlashOn == false)) {
                     isFlashOn = true;
                     Parameters parameters = myCamera.getParameters();
                     parameters.setFlashMode(Parameters.FLASH_MODE_TORCH);
                     myCamera.setParameters(parameters);
                } else {
                  if ((recording == true) && (isFlashOn == true)) {
                       isFlashOn = false;
                       Parameters parameters = myCamera.getParameters();
                       parameters.setFlashMode(Parameters.FLASH_MODE_OFF);
                       myCamera.setParameters(parameters);
                  }
                }
                if (ba.subExists(eventName + "_flash_toggled")) {
                  ba.raiseEvent2(ba, false, eventName + "_flash_toggled", true, new Object[]{isFlashOn});
                }
              }
          });
        } else {
//          if (debugMessages == true)
//             BA.Log("In addListener2 - Device has no flash");
        }   
      }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    /**
     * Toggle stop/start of video recording
     */
    public void setStartStopRecording() {
		if(recording){
//                  if (debugMessages == true)
//                    BA.Log("In setStartStopRecording, busy recording, and now going to stop recording");
                  recording = false; 
                  // stop recording and release camera
                  mediaRecorder.stop();  // stop the recording
                  releaseMediaRecorder(); // release the MediaRecorder object
                
                  //Exit after saved
                  releaseCamera();
                  stopTimer();

		}else{

//                  if (debugMessages == true)
//                    BA.Log("In setStartStopRecording, not recording, and now going to start recording");
				
		  //Release Camera before MediaRecorder start
		  releaseCamera();
				
		  if(!prepareMediaRecorder()){
//                       if (debugMessages == true)
//                          BA.Log("In setStartStopRecording and failed prepare the media recorder");
		       	Toast.makeText(ba.applicationContext, "Fail in prepareMediaRecorder()!\n - Ended -", Toast.LENGTH_LONG).show();
		       	releaseCamera();
		  }

/*                   mHandler.postDelayed(new Runnable() {
                      public void run() {
                      }
                  }, 10000);
 */
		try {
			Thread.sleep(3000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
 
 
				  Toast.makeText(ba.applicationContext, "Got to 1", Toast.LENGTH_LONG).show();
                  mediaRecorder.start();
                  startTimer(maximumduration); 

		          recording = true;


                  Parameters parameters = myCamera.getParameters();
                  List<String> focusModes = parameters.getSupportedFocusModes();
//                  if (debugMessages == true)
//                        BA.Log("List of supported focus modes = " + focusModes);
                  if (focusModes.contains(Parameters.FOCUS_MODE_CONTINUOUS_VIDEO)) {
                     parameters.setFocusMode(Parameters.FOCUS_MODE_CONTINUOUS_VIDEO);
                     
                  } else {
                     if (focusModes.contains(Parameters.FOCUS_MODE_INFINITY)) {
                        parameters.setFocusMode(Parameters.FOCUS_MODE_INFINITY);
                     }
                  }
                 
                  myCamera.setParameters(parameters);

		}
   }


    private Camera getCameraInstance(){
		// TODO Auto-generated method stub

        getBackFacingCamera();
        getFrontFacingCamera();   
    

//        if (debugMessages == true)
//              BA.Log("In getCameraInstance and found BackFacingCameraID = " + getBackFacingCamera());

//        if (debugMessages == true)
//              BA.Log("In getCameraInstance and found FrontFacingCameraID = " + getFrontFacingCamera());

        if ((CAMERA_BACK == 0) && (CAMERA_FRONT == 1))
           ctu = ctu;

        if ((CAMERA_BACK == 0) && (CAMERA_FRONT == -1))
           ctu = 0;

        if ((CAMERA_BACK == -1) && (CAMERA_FRONT == 0))
           ctu = 0;


        Camera c = null;
        try {    
            c = Camera.open(ctu); // attempt to get a Camera instance

            Camera.Parameters cameraParams = c.getParameters();
//          cameraParams.set( "cam_mode", 1 ); 
            List<Camera.Size> supportedPreviewSizes = cameraParams.getSupportedPreviewSizes();
            cntr = 0;
            int cwidth = 0;
            int cheight = 0;
            for (int i = 0; i < supportedPreviewSizes.size(); i++) {
               Camera.Size size = supportedPreviewSizes.get(i);
               cwidth = size.width;
               cheight = size.height;

            }
        }
        catch (Exception e){
            // Camera is not available (in use or does not exist)
            c = Camera.open(); // attempt to get a Camera instance

            Camera.Parameters cameraParams = c.getParameters();
            List<Camera.Size> supportedPreviewSizes = cameraParams.getSupportedPreviewSizes();
            cntr = 0;
            int cwidth = 0;
            int cheight = 0;
            for (int i = 0; i < supportedPreviewSizes.size(); i++) {
               Camera.Size size = supportedPreviewSizes.get(i);
               cwidth = size.width;
               cheight = size.height;

            }
        }
        return c; // returns null if camera is unavailable
    }

	
	private boolean prepareMediaRecorder(){
	    myCamera = getCameraInstance();
            

	    mediaRecorder = new MediaRecorder();

            mediaRecorder.setOnInfoListener(infoListener);


            myCamera.setDisplayOrientation(0);


            mediaRecorder.setOrientationHint(0);           //this turns the thumbnail to the correct orientation but the video is still turned 90 degrees.


	    myCamera.unlock();
	    mediaRecorder.setCamera(myCamera);

	    mediaRecorder.setAudioSource(MediaRecorder.AudioSource.CAMCORDER);
	    mediaRecorder.setVideoSource(MediaRecorder.VideoSource.CAMERA);


            if ((CAMERA_BACK == 0) && (CAMERA_FRONT < 1))         //there is only a back facing camera so use it by default
	        mediaRecorder.setProfile(CamcorderProfile.get(qualityvalue));

            if ((CAMERA_BACK < 0) && (CAMERA_FRONT <= 1))
		mediaRecorder.setProfile(CamcorderProfile.get(getFrontFacingCamera(), qualityvalue));
            
            if ((CAMERA_BACK >=0) && (CAMERA_FRONT >=0))    
                 mediaRecorder.setProfile(CamcorderProfile.get(qualityvalue));                 //original code 


            File folder = new File(Environment.getExternalStorageDirectory(), "/" + foldername);
            if (!folder.exists()) {
                folder.mkdirs();
            }

     
            java.util.Date date = new java.util.Date();
            String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss", Locale.ENGLISH) .format(date.getTime());


            if (atstfn == true)
	        mediaRecorder.setOutputFile("/sdcard/" + foldername + "/" + videoname + "_" + timeStamp + ".mp4");

            if (atstfn == false)
	        mediaRecorder.setOutputFile("/sdcard/" + foldername + "/" + videoname + ".mp4");


            mediaRecorder.setMaxDuration(maximumduration); // Set max duration milliseconds
            mediaRecorder.setMaxFileSize(maximumfilesize); // Set max file size 5M

	    mediaRecorder.setPreviewDisplay(cv.getHolder().getSurface());

	    try {
	        mediaRecorder.prepare();
	    } catch (IllegalStateException e) {
//                BA.Log("IllegalStateException " + e.toString());
	        releaseMediaRecorder();
	        return false;
	    } catch (IOException e) {
//                BA.Log("IOException " + e.toString());
	        releaseMediaRecorder();
	        return false;
	    }
	    return true;
		
	}

    /**
     * Release the camera and media recorder so that they can be
     * used by other applications
     */
    public void releaseResources() {
        releaseMediaRecorder();       // if you are using MediaRecorder, release it first
        releaseCamera();              // release the camera immediately on pause event
    }

    private void releaseMediaRecorder(){
        if (mediaRecorder != null) {
            mediaRecorder.reset();   // clear recorder configuration
            mediaRecorder.release(); // release the recorder object
            mediaRecorder = null;
            myCamera.lock();           // lock camera for later use
        }
    }

    private void releaseCamera(){
        if (myCamera != null){
            myCamera.release();        // release the camera for other applications
            myCamera = null;
        }
    }

    private int maximumduration = 60000;                 //milliseconds
    /**
     * Set the maximum duration of the recording
     * Default value is 60000ms
     * If maximum file size is reached before maximum duration then
     * maximum file size will take preference and will stop the recording
     */
    public void setMaximimDuration(int maximumduration) {
         this.maximumduration = maximumduration;
    }

    private long maximumfilesize = 5000000;                 //bytes
    /**
     * Set the maximum file size for recording
     * Default value is 5000000 bytes = 5MB
     * If maximum duration is reached before maximum file size then
     * maximum duration will take preference and will stop the recording
     */
    public void setMaximumFileSize(long maximumfilesize) {
         this.maximumfilesize = maximumfilesize;
    }

    /**
     * Toggle the flash on/off should the camera in use have a flash
     */
    public void toggleFlash() {

              if ((recording == true) && (isFlashOn == false)) {
                   isFlashOn = true;
                   Parameters parameters = myCamera.getParameters();
                   List<String> flashModes = parameters.getSupportedFlashModes();
                   if (flashModes != null) {
                     parameters.setFlashMode(Parameters.FLASH_MODE_TORCH);
                     parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_CONTINUOUS_VIDEO);
                     myCamera.setParameters(parameters);
                     if (ba.subExists(eventName + "_flash_toggled")) {
                       ba.raiseEvent2(ba, false, eventName + "_flash_toggled", true, new Object[]{isFlashOn});
                     }
                   }
              } else {
                if ((recording == true) && (isFlashOn == true)) {
                     isFlashOn = false;
                     Parameters parameters = myCamera.getParameters();
                     List<String> flashModes = parameters.getSupportedFlashModes();
                     if (flashModes != null) {
                       parameters.setFlashMode(Parameters.FLASH_MODE_OFF);
                       parameters.setFocusMode(Camera.Parameters.FOCUS_MODE_CONTINUOUS_VIDEO);
                       myCamera.setParameters(parameters);
                       if (ba.subExists(eventName + "_flash_toggled")) {
                         ba.raiseEvent2(ba, false, eventName + "_flash_toggled", true, new Object[]{isFlashOn});
                       }
                     }
                }
              }
    }


    /**
     * Zoom In with increments of 1 at a time
     */
    public void ZoomIn() {
      if (myCamera != null) {
        Parameters parameters = myCamera.getParameters();
        if(parameters.isZoomSupported()){    
           maxZoomLevel = parameters.getMaxZoom();
//         BA.Log("Max Zoom Level = " + maxZoomLevel);
           if(currentZoomLevel < maxZoomLevel){
              currentZoomLevel++;
              parameters.setZoom(currentZoomLevel);
              myCamera.setParameters(parameters);
           }
        }
      }
    }

    /**
     * Zoom Out with decrements of 1 at a time
     */
    public void ZoomOut() {
      if (myCamera != null) {
        Parameters parameters = myCamera.getParameters();
        if(parameters.isZoomSupported()){    
            if(currentZoomLevel > 0){
                currentZoomLevel--;
                parameters.setZoom(currentZoomLevel);
                myCamera.setParameters(parameters);
            }
        }
      }
    }


    /**
     * Zoom In/Out with a slider
     */
    public void setZoomWithSlider(int slidervalue) {
      if (myCamera != null) {
        Parameters parameters = myCamera.getParameters();
        if(parameters.isZoomSupported()){    
           maxZoomLevel = parameters.getMaxZoom();
           if(slidervalue < maxZoomLevel){
              parameters.setZoom(slidervalue);
              myCamera.setParameters(parameters);
           }
        }
      }
    }

    private String videoname = "";
    /**
     * Set the name of your video recording file
     * See also method AddTimeStampToFileName to add a timestamp to the file name
     */
    public void setVideoName (String videoname) {
       this.videoname = videoname;
    }

    /**
     * Set the video quality based on one of the supported qualities
     * See the call to getBackSupportedVideoQuality(0) and getFrontSupportedVideoQuality(1)
     * If the device has a front camera only the call above need to be getFrontSupportedVideoQuality(0)	i.e cameraID = 0	
     */
    public void setVideoQuality (int qualityvalue) {
        this.qualityvalue = qualityvalue;
    }

    private MediaRecorder.OnInfoListener infoListener = new MediaRecorder.OnInfoListener() {
        @Override
        public void onInfo(MediaRecorder mr, int what, int extra) {
//          BA.Log("WHAT = " + what);
            if (what == 801) {
              if (stm == true) {
                Toast.makeText(ba.applicationContext, mfsrtm, Toast.LENGTH_LONG).show();
              }
                if (ba.subExists(eventName + "_max_file_size_reached")) {
                   boolean maxfilesizereached = true;
                   ba.raiseEvent2(ba, false, eventName + "_max_file_size_reached", true, new Object[]{maxfilesizereached});            
                }
                if (scomsd == true) {
                   stopTimer();
                   recording = false; 
                   // stop recording and release camera
                   mediaRecorder.stop();  // stop the recording
                   releaseMediaRecorder(); // release the MediaRecorder object
                
                   //Exit after saved
                   releaseCamera();
                   //setStartStopRecording();
                }
            }

            if (what == 800) {
              if (stm == true) {
                Toast.makeText(ba.applicationContext, mdrtm, Toast.LENGTH_LONG).show();
              }
                if (ba.subExists(eventName + "_max_duration_reached")) {
                   boolean maxdurationreached = true;
                   ba.raiseEvent2(ba, false, eventName + "_max_duration_reached", true, new Object[]{maxdurationreached});            
                }
                if (scomsd == true) {
                   stopTimer();
                   recording = false; 
                   // stop recording and release camera
                   mediaRecorder.stop();  // stop the recording
                   releaseMediaRecorder(); // release the MediaRecorder object
                
                   //Exit after saved
                   releaseCamera();
                   //setStartStopRecording();
                }               
            }
        }
    };

    private boolean stm = true;
    /**
     * Show toast messages	
     */
    public void setShowToastMessages(boolean stm) {
        this.stm = stm;
    }

    private boolean scomsd = false;
    /**
     * Stop the recording if maximum size or maximum duration has been reached	
     */
    public void setStopCameraOnMaxSizeDuration(boolean scomsd) {
        this.scomsd = scomsd;
    }

    private int ctu = 0;
    /**
     * Set the camera to be use	for recording
     * For a device with front and back cameras ---> front = 1 and back = 0
     * for a device with a front camera only ---> front = 0
     * for a device with a back facing camera only ---> back = 0
     * Use avc1.BackFacingCamera and avc1.FrontFacingCamera to get the camera ID's
     */
    public void setCameraToUse (int ctu) {
      this.ctu = ctu;
    }


    private String mdrtm = "";
    /**
     * Set the toast message to be displayed when maximum duration has been reached
     */
    public void setMaximumDurationReachedToastMessage(String mdrtm) {
        this.mdrtm = mdrtm;
    }

    private String mfsrtm = "";
    /**
     * Set the toast message to be displayed when maximum file size has been reached
     */
    public void setMaximumFileSizeReachedToastMessage(String mfsrtm) {
        this. mfsrtm = mfsrtm;
    }


    private String foldername = "Videos";
    /**
     * Set the folder name of where videos will be stored
     * It starts from the root folder of your device
     * If the folder does not exist it will be created automatically
     * eg avc1.VideoFolderName = "MyVideoFolder/Videos" 
     * this will create a folder named MyVideoFolder in the root folder of your device
     * It will then create a sub folder named Videos in folder MyVideoFolder
     * Recorded videos will be stored in the folder named Videos
     */
    public void setVideoFolderName(String foldername) {
       this.foldername = foldername;
    }


    private void startTimer(long time){
           counter = new CountDownTimer(time, 1000){
           public void onTick(long millisUntilDone){

                    String timestring = "" + String.format("%d:%d", 
                    TimeUnit.MILLISECONDS.toMinutes(millisUntilDone),
                    TimeUnit.MILLISECONDS.toSeconds(millisUntilDone) - 
                    TimeUnit.MINUTES.toSeconds(TimeUnit.MILLISECONDS.toMinutes(millisUntilDone)));
                    if (oldtimestring != timestring) {
                      if (ba.subExists(eventName + "_recording_time_remaining")) {
                         ba.raiseEvent2(ba, false, eventName + "_recording_time_remaining", true, new Object[]{timestring});            
                      }
                      oldtimestring = timestring;
                    }
           }

           public void onFinish() {
                      if (ba.subExists(eventName + "_recording_time_remaining")) {
                         boolean maxfilesizereached = true;
                         ba.raiseEvent2(ba, false, eventName + "_recording_time_remaining", true, new Object[]{"00:00"});            
                      }

           }
       }.start();
    }


    /**
     * it is used in Activity_Pause (UserClosed As Boolean)
     * to ensure that the timer used inside the library 
     * is stopped in case it is still running when the user terminates the activity
     */
    public void stopTimer() {

         if(counter != null) {
             counter.cancel();
             counter = null;
             oldtimestring = "";
         }
    }


    private boolean atstfn = true;
    /**
     * Add a time stamp to the file name
     * The video will now be stored as YourVideoName_yyyyMMdd_HHmmss.MP4
     */
    public void setAddTimeStampToFileName(boolean atstfn) {
        this.atstfn = atstfn;
    }




        private Camera initFrontCamera(){                            //if there is a front facing camera then initialize it
	   myCamera = Camera.open(getFrontFacingCamera());
           return myCamera;
        }


        private Camera initBackCamera(){                            //if there is a back facing camera then initialize it
	   myCamera = Camera.open(getBackFacingCamera());
//           BA.Log("BACK facing CAMERA = " + myCamera);
           return myCamera;
        }


       /**
        * Check if the device has a camera of any sort
        */
	public boolean hasCamera() {
		// check if the device has camera
		if (ba.applicationContext.getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA_ANY)) {
//                        BA.Log("got a camera");
			return true;
		} else {
//                        BA.Log("dont have a camera");
			return false;
		}
	}


       /**
        * Check if the device has a flash
        */
        public boolean hasFlash() {
           if (myCamera == null) {
               return false;
           } else {

             Camera.Parameters parameters = myCamera.getParameters();

             if (parameters.getFlashMode() == null) {
                return false;
            }
             List<String> supportedFlashModes = parameters.getSupportedFlashModes();
             if (supportedFlashModes == null || supportedFlashModes.isEmpty() || supportedFlashModes.size() == 1 && supportedFlashModes.get(0).equals(Camera.Parameters.FLASH_MODE_OFF)) {
                 return false;
             }
             return true;
           }
        }


       /**
        * Get the ID of the front facing camera
        * If the device has a front and back camera then the ID = 1
        * If the device has a front facing camera only then the ID = 0
        * It will return the ID as -1 if there is no front facing camera
        */
	public int getFrontFacingCamera() {
		int cameraId = -1;
		// Search for the front facing camera
		int numberOfCameras = Camera.getNumberOfCameras();
		for (int i = 0; i < numberOfCameras; i++) {
			CameraInfo info = new CameraInfo();
			Camera.getCameraInfo(i, info);
			if (info.facing == CameraInfo.CAMERA_FACING_FRONT) {
				cameraId = i;
                                getFrontSupportedVideoQuality(cameraId);
				cameraFront = true;
				break;
			}
		}
//                BA.Log("Front Facing Camera ID = " + cameraId);
                CAMERA_FRONT = cameraId;
		return cameraId;
	}


       /**
        * Get the ID of the back facing camera
        * If the device has a front and back camera then the ID = 0
        * If the device has a back facing camera only then the ID = 0
        * It will return the ID as -1 if there is no back facing camera
        */
	public int getBackFacingCamera() {
		int cameraId = -1;
		// Search for the back facing camera
		// get the number of cameras
		int numberOfCameras = Camera.getNumberOfCameras();
		// for every camera check
		for (int i = 0; i < numberOfCameras; i++) {
			CameraInfo info = new CameraInfo();
			Camera.getCameraInfo(i, info);
			if (info.facing == CameraInfo.CAMERA_FACING_BACK) {
				cameraId = i;
                                getBackSupportedVideoQuality(cameraId);
				cameraFront = false;
				break;
			}
		}
//                BA.Log("Back Facing Camera ID = " + cameraId);
                CAMERA_BACK = cameraId;
		return cameraId;
	}




        private ArrayList<String> backsupported; 
       /**
        * Get a list of the video qualities that the back facing camera supports
        * It returns a list of Strings with values such as 
        * QUALITY_1080P, QUALITY_720P, QUALITY_480P, QUALITY_CIF, QUALITY_QCIF, 
        * QUALITY_QVGA, QUALITY_LOW, QUALITY_HIGH
        * Use for eg avc1.VideoQuality = avc1.QUALITY_720P to set the quality
        * that you want to use during recording
        */
        public ArrayList<String> getBackSupportedVideoQuality(int cameraId) {
           backsupported = new ArrayList<String>();
	   // Check for supported quality
//	   if (CamcorderProfile.hasProfile(cameraId, CamcorderProfile.QUALITY_2160P)) {
//   		backsupported.add("QUALITY_2160P");
//	   }
	   if (CamcorderProfile.hasProfile(cameraId, CamcorderProfile.QUALITY_1080P)) {
	   	backsupported.add("QUALITY_1080P");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_720P)) {
		backsupported.add("QUALITY_720P");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_480P)) {
		backsupported.add("QUALITY_480P");
	   }
	   /** SPRD: 255888 FrontCamera Don't Show VideoSize In Recording. @{ */
	   if (CamcorderProfile.hasProfile(cameraId, CamcorderProfile.QUALITY_CIF)) {
		backsupported.add("QUALITY_CIF");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_QCIF)) {
		backsupported.add("QUALITY_QCIF");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_QVGA)) {
		backsupported.add("QUALITY_QVGA");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_LOW)) {
		backsupported.add("QUALITY_LOW");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_HIGH)) {
		backsupported.add("QUALITY_HIGH");
	   }
	   /** }@ */
//           BA.Log("BACK CAMERA SUPPORTED = " + backsupported);
	   return backsupported;

        }


        private ArrayList<String> frontsupported; 
       /**
        * Get a list of the video qualities that the front facing camera supports
        * It returns a list of Strings with values such as 
        * QUALITY_1080P, QUALITY_720P, QUALITY_480P, QUALITY_CIF, QUALITY_QCIF, 
        * QUALITY_QVGA, QUALITY_LOW, QUALITY_HIGH
        * Use for eg avc1.VideoQuality = avc1.QUALITY_720P to set the quality
        * that you want to use during recording
        */
        public ArrayList<String> getFrontSupportedVideoQuality(int cameraId) {
           frontsupported = new ArrayList<String>();
	   // Check for supported quality
//	   if (CamcorderProfile.hasProfile(cameraId, CamcorderProfile.QUALITY_2160P)) {
//		frontsupported.add("QUALITY_2160P");
//	   }
	   if (CamcorderProfile.hasProfile(cameraId, CamcorderProfile.QUALITY_1080P)) {
		frontsupported.add("QUALITY_1080P");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_720P)) {
		frontsupported.add("QUALITY_720P");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_480P)) {
		frontsupported.add("QUALITY_480P");
	   }
	   /** SPRD: 255888 FrontCamera Don't Show VideoSize In Recording. @{ */
	   if (CamcorderProfile.hasProfile(cameraId, CamcorderProfile.QUALITY_CIF)) {
		frontsupported.add("QUALITY_CIF");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_QCIF)) {
		frontsupported.add("QUALITY_QCIF");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_QVGA)) {
		frontsupported.add("QUALITY_QVGA");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_LOW)) {
		frontsupported.add("QUALITY_LOW");
	   }
	   if (CamcorderProfile
			.hasProfile(cameraId, CamcorderProfile.QUALITY_HIGH)) {
		frontsupported.add("QUALITY_HIGH");
	   }
	   /** }@ */
//           BA.Log("FRONT CAMERA SUPPORTED = " + frontsupported);
	   return frontsupported;

        }

  
}    //end of class













